#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <signal.h>

#define SOCKET_PORT 50000


void error(const char *msg)
{
    perror(msg);
    exit(1);
}

int main()
{
     int sockfd, newsockfd, portno;
     socklen_t clilen;
     char buffer[256];
     struct sockaddr_in serv_addr, cli_addr;
     int n;

     signal (SIGCHLD, SIG_IGN);

     sockfd = socket(AF_INET, SOCK_STREAM, 0);


     if (sockfd < 0) 
        error("ERROR opening socket");

     bzero((char *) &serv_addr, sizeof(serv_addr));

     serv_addr.sin_family = AF_INET;
     serv_addr.sin_addr.s_addr = INADDR_ANY;
     serv_addr.sin_port = htons(SOCKET_PORT);

     if (bind(sockfd, (struct sockaddr *) &serv_addr,
              sizeof(serv_addr)) < 0) 
              error("ERROR on binding");

     listen(sockfd,5);

     clilen = sizeof(cli_addr);

while (1)
  {

    printf("Server %d accepting connections\n", getpid());


     newsockfd = accept(sockfd, 
                 (struct sockaddr *) &cli_addr, 
                 &clilen);

     printf("Server %d: accepted = %d\n", getpid(), newsockfd);


     if (newsockfd < 0) 
       { printf("Accept error on server %d: \n", getpid());
	 error("ERROR on accept"); 
       }

     printf("Server %d: connection %d accepted\n", getpid(), newsockfd);

     if (fork() == 0)
       { // child, servin client

    while (1)
{
     bzero(buffer,256);
     n = read(newsockfd,buffer,255);
     if (n < 0) error("ERROR reading from socket");
     printf("PID %d: Here is the message: %s\n", getpid(), buffer);

     n = write(newsockfd,"I got your message",18);
     if (n < 0) error("ERROR writing to socket");

    if (strcmp(buffer, "endofit\n") == 0) 
    /* end of game */
      {
         n = write(newsockfd,"\nBye\n", 4);
         if (n < 0) error("ERROR writing to socket");

         close(newsockfd);
         exit(0);
      }

} /* end child while loop */

       } // end of child serving client

     else
       { // father, accepting connections

     close(newsockfd);
 
       } // end of father, accepting connections

  }  // serving loop

     close(sockfd);   

     return 0; 
}
